diff --git a/src/main/java/net/minecraft/core/item/BowItem.java b/src/main/java/net/minecraft/core/item/BowItem.java
index a1a7260f8..54af1774f 100644
--- a/src/main/java/net/minecraft/core/item/BowItem.java
+++ b/src/main/java/net/minecraft/core/item/BowItem.java
@@ -6,8 +6,8 @@ package net.minecraft.core.item;
 //            ArrowProjectile, ItemStack
 
 import net.minecraft.core.entity.projectile.ArrowProjectile;
-import net.minecraft.core.entity.projectile.ArrowProjectileGolden;
-import net.minecraft.core.entity.projectile.ArrowProjectilePurple;
+import net.minecraft.core.entity.projectile.GoldenArrowProjectile;
+import net.minecraft.core.entity.projectile.PurpleArrowProjectile;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
 
@@ -37,7 +37,7 @@ public class BowItem extends Item
             itemstack.damageItem(1, entityplayer);
             world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3f, 1.0F / (itemRand.nextFloat() * 0.4F + 0.8F));
             if (!world.isClientSide) {
-                world.entityJoinedWorld(new ArrowProjectilePurple(world, entityplayer, false));
+                world.entityJoinedWorld(new PurpleArrowProjectile(world, entityplayer, false));
             }
         }
         else if (entityplayer.inventory.consumeInventoryItem(Items.AMMO_ARROW_GOLD.id))
@@ -46,7 +46,7 @@ public class BowItem extends Item
             world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3f, 1.0F / (itemRand.nextFloat() * 0.4F + 0.8F));
             if(!world.isClientSide)
             {
-                world.entityJoinedWorld(new ArrowProjectileGolden(world, entityplayer, true));
+                world.entityJoinedWorld(new GoldenArrowProjectile(world, entityplayer, true));
             }
         }
         else if(entityplayer.inventory.consumeInventoryItem(Items.AMMO_ARROW.id))
diff --git a/src/main/java/net/minecraft/core/item/FoodItem.java b/src/main/java/net/minecraft/core/item/FoodItem.java
index a13f3b984..b0ab4fe5c 100644
--- a/src/main/java/net/minecraft/core/item/FoodItem.java
+++ b/src/main/java/net/minecraft/core/item/FoodItem.java
@@ -26,6 +26,7 @@ public class FoodItem extends Item
                 && entityplayer.getHealth() + entityplayer.getTotalHealingRemaining() < entityplayer.getMaxHealth()
                 && itemstack.consumeItem(entityplayer)) {
             entityplayer.eatFood(this);
+            world.playSoundAtEntity(entityplayer, entityplayer, ticksPerHeal >= 10 ? "random.bite_extended" : "random.bite", 0.5f + (itemRand.nextFloat() - itemRand.nextFloat()) * 0.1f, 1.1f + (itemRand.nextFloat() - itemRand.nextFloat()) * 0.1f);
         }
         return itemstack;
     }
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/ArrowNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/ArrowNetEntry.java
index 86ebf4325..4ca4c183e 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/ArrowNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/ArrowNetEntry.java
@@ -3,8 +3,8 @@ package net.minecraft.core.net.entity.entries;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.projectile.ArrowProjectile;
-import net.minecraft.core.entity.projectile.ArrowProjectileGolden;
-import net.minecraft.core.entity.projectile.ArrowProjectilePurple;
+import net.minecraft.core.entity.projectile.GoldenArrowProjectile;
+import net.minecraft.core.entity.projectile.PurpleArrowProjectile;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.AddEntityPacket;
@@ -42,9 +42,9 @@ public class ArrowNetEntry implements IVehicleEntry<ArrowProjectile>, ITrackedEn
     @Override
     public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
         if (metadata == 2) {
-            return new ArrowProjectileGolden(world, x, y, z);
+            return new GoldenArrowProjectile(world, x, y, z);
         } else if (metadata == 1) {
-            return new ArrowProjectilePurple(world, x, y, z);
+            return new PurpleArrowProjectile(world, x, y, z);
         } else {
             return new ArrowProjectile(world, x, y, z, metadata);
         }
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/ArmorSlot.java b/src/main/java/net/minecraft/core/player/inventory/slot/ArmorSlot.java
index f5a38946f..23483ddae 100644
--- a/src/main/java/net/minecraft/core/player/inventory/slot/ArmorSlot.java
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/ArmorSlot.java
@@ -3,13 +3,18 @@ package net.minecraft.core.player.inventory.slot;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.IArmorItem;
+import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.block.BlockItem;
+import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.player.inventory.container.Inventory;
 import net.minecraft.core.player.inventory.menu.InventoryMenu;
 import net.minecraft.core.player.inventory.container.Container;
 
+import java.util.HashSet;
+import java.util.Set;
+
 public class ArmorSlot extends Slot
 {
     public static String[] armorOutlines = new String[]{
@@ -56,7 +61,9 @@ public class ArmorSlot extends Slot
 	public void setChanged()
     {
         super.setChanged();
-        
+
+        Set<ArmorMaterial> wornMaterials = new HashSet<>();
+
         int count = 0;
         
         for (int i = 0; i < menu.slots.size(); i++)
@@ -68,6 +75,12 @@ public class ArmorSlot extends Slot
 				{
         			count++;
 				}
+                if (stack != null) {
+                    Item item = stack.getItem();
+                    if (item instanceof IArmorItem){
+                        wornMaterials.add(((IArmorItem) item).getArmorMaterial());
+                    }
+                }
         	}
         }
         
@@ -75,6 +88,9 @@ public class ArmorSlot extends Slot
         {
         	menu.inventory.player.triggerAchievement(Achievements.GET_CHAINMAIL);
         }
+        if (wornMaterials.size() >= 4) {
+            menu.inventory.player.triggerAchievement(Achievements.ALL_ARMOR_TYPES);
+        }
         
         if (getItem() != null && container instanceof Inventory) {
             Player player = ((Inventory) container).player;
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/ResultSlot.java b/src/main/java/net/minecraft/core/player/inventory/slot/ResultSlot.java
index fb70a181d..b9700428f 100644
--- a/src/main/java/net/minecraft/core/player/inventory/slot/ResultSlot.java
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/ResultSlot.java
@@ -46,6 +46,8 @@ public class ResultSlot extends Slot
 		if(item.id == Blocks.FURNACE_STONE_IDLE.id) thePlayer.addStat(Achievements.BUILD_FURNACE, 1);
 		if(item.id == Items.FOOD_BREAD.id) thePlayer.addStat(Achievements.MAKE_BREAD, 1);
 		if(item.id == Items.FOOD_CAKE.id) thePlayer.addStat(Achievements.BAKE_CAKE, 1);
+		if(item.id == Items.BUCKET_ICECREAM.id) thePlayer.addStat(Achievements.CRAFT_ICECREAM, 1);
+		if(item.id == Items.FOOD_PUMPKIN_PIE.id) thePlayer.addStat(Achievements.CRAFT_PUMPKIN_PIE, 1);
 		if(item.id == Items.HANDCANNON_UNLOADED.id) thePlayer.addStat(Achievements.CRAFT_HANDCANNON, 1);
 		if(item instanceof HoeToolItem) thePlayer.addStat(Achievements.BUILD_HOE, 1);
 		if(item instanceof SwordToolItem) thePlayer.addStat(Achievements.BUILD_SWORD, 1);
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
index cb2a2efb8..e2164ccc7 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
@@ -5,6 +5,7 @@ import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.block.entity.ChestBlockEntity;
 import net.minecraft.core.block.entity.DispenserBlockEntity;
 import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
@@ -220,9 +221,16 @@ public class WorldFeatureLabyrinth extends WorldFeature
             world.setBlockWithNotify(x, y, z, 0);
             return true;
         }
-        return world.getBlockMaterial(x, y, z) == Material.grass ||
+        return BlockTags.CAVES_CUT_THROUGH.appliesTo(world.getBlock(x, y, z)) ||
+                world.getBlockMaterial(x, y, z) == Material.grass ||
                 world.getBlockMaterial(x, y, z) == Material.dirt ||
                 world.getBlockMaterial(x, y, z) == Material.stone ||
+                world.getBlockMaterial(x, y, z) == Material.slate ||
+                world.getBlockMaterial(x, y, z) == Material.marble ||
+                world.getBlockMaterial(x, y, z) == Material.limestone ||
+                world.getBlockMaterial(x, y, z) == Material.basalt ||
+                world.getBlockMaterial(x, y, z) == Material.granite ||
+                world.getBlockMaterial(x, y, z) == Material.permafrost ||
                 world.getBlockMaterial(x, y, z) == Material.sand ||
                 world.getBlockMaterial(x, y, z) == Material.moss;
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
index 5e50c5f3f..9c351498c 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
@@ -100,7 +100,7 @@ public class WorldFeatureLake extends WorldFeature
                 {
                     if(shouldPlaceLiquid[(dx * 16 + dz) * 8 + dy])
                     {
-                        world.setBlock(x + dx, y + dy, z + dz, dy < 4 ? liquidId : 0);
+                        world.setBlockWithNotify(x + dx, y + dy, z + dz, dy < 4 ? liquidId : 0);
                     }
                 }
 
diff --git a/src/main/java/net/minecraft/server/net/PlayerList.java b/src/main/java/net/minecraft/server/net/PlayerList.java
index 864b73f0e..67f0580cc 100644
--- a/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -1,8 +1,10 @@
 package net.minecraft.server.net;
 
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.server.entity.player.ServerPlayer;
 import net.minecraft.server.net.handler.LoginPacketHandler;
 import net.minecraft.core.net.packet.*;
@@ -226,13 +228,24 @@ public class PlayerList
         serverPlayer.playerNetServerHandler.sendPacket(new RespawnPacket((byte) serverPlayer.dimension, (byte) Registries.WORLD_TYPES.getNumericIdOfItem(worldserver1.worldType)));
         worldserver.removePlayer(serverPlayer);
         serverPlayer.removed = false;
-        double d = serverPlayer.x;
-        double d1 = serverPlayer.z;
-        double d2 = 8D;
-
-        d *= Dimension.getCoordScale(lastDim, newDim);
-        d1 *= Dimension.getCoordScale(lastDim, newDim);
-        serverPlayer.moveTo(d, serverPlayer.y, d1, serverPlayer.yRot, serverPlayer.xRot);
+        double x = serverPlayer.x;
+        double y = serverPlayer.y;
+        double z = serverPlayer.z;
+
+        x *= Dimension.getCoordScale(lastDim, newDim);
+        z *= Dimension.getCoordScale(lastDim, newDim);
+        serverPlayer.moveTo(x, y, z, serverPlayer.yRot, serverPlayer.xRot);
+        ChunkCoordinates newCoordinates = new ChunkCoordinates(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
+        if (serverPlayer.dimensionEnterCoordinate != null) {
+            double dx = serverPlayer.dimensionEnterCoordinate.x - x;
+            double dy = serverPlayer.dimensionEnterCoordinate.y - y;
+            double dz = serverPlayer.dimensionEnterCoordinate.z - z;
+            double distSqr = (dx * dx) + (dy * dy) + (dz * dz);
+            if (distSqr > 8000 * 8000) {
+                serverPlayer.addStat(Achievements.FAST_TRAVEL, 1);
+            }
+        }
+        serverPlayer.dimensionEnterCoordinate = newCoordinates;
         if (serverPlayer.isAlive())
         {
             worldserver.updateEntityWithOptionalForce(serverPlayer, false);
@@ -241,7 +254,7 @@ public class PlayerList
         if (serverPlayer.isAlive())
         {
             worldserver1.entityJoinedWorld(serverPlayer);
-            serverPlayer.moveTo(d, serverPlayer.y, d1, serverPlayer.yRot, serverPlayer.xRot);
+            serverPlayer.moveTo(x, serverPlayer.y, z, serverPlayer.yRot, serverPlayer.xRot);
             worldserver1.updateEntityWithOptionalForce(serverPlayer, false);
             if (generatePortal){
                 worldserver1.chunkProviderServer.chunkLoadOverride = true;
